#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.14 $
#
#   last change: $Author: obo $ $Date: 2007/10/24 12:18:53 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

PRJ=.

PRJNAME=nas
TARGET=nas

# --- Settings -----------------------------------------------------

.INCLUDE :	settings.mk

# --- Files --------------------------------------------------------

.IF "$(GUI)"!="UNX" || "$(OS)"=="IRIX" || "$(SYSTEM_NAS)"=="YES" || "$(GUIBASE)"=="aqua"

dummy:
.IF "$(SYSTEM_NAS)"=="YES"
	@echo "Using system nas..."
.ELSE
	.IF "$(GUIBASE)"=="aqua"
	@echo "Nothing to build for GUIBASE $(GUIBASE)"
	.ELSE
	@echo "Nothing to build for OS $(OS)"
	.ENDIF # "$(GUIBASE)"=="aqua"
.ENDIF

.ELSE           # "$(GUI)"!="UNX" || "$(OS)"=="IRIX" || "$(SYSTEM_NAS)"=="YES"

TARFILE_NAME=nas-1.6

PATCH_FILE_NAME=nas-1.6.patch

.IF "$(SYSBASE)"!=""
.IF "$(OS)"=="LINUX"
CC+:=-L$(SYSBASE)$/usr$/X11R6/lib
CXX+:=-L$(SYSBASE)$/usr$/X11R6/lib
.ENDIF          # "$(OS)"=="LINUX"
.ENDIF          # "$(SYSBASE)"!=""

#relative to CONFIGURE_DIR
CONFIGURE_ACTION=xmkmf

BUILD_DIR=$(CONFIGURE_DIR)
BUILD_ACTION=make World
.IF "$(OS)"!="SOLARIS"
BUILD_FLAGS=CC="$(CC)" CXX="$(CXX)" -j$(MAXPROCESS)
.ELSE
BUILD_FLAGS=CC="$(CC)" CXX="$(CXX)" 
.ENDIF

OUT2LIB= \
	lib/audio/libaudio.a
	
OUT2INC= \
	include/audio/*.h

.ENDIF          # "$(GUI)"!="UNX" || "$(OS)" == "IRIX" || "$(SYSTEM_NAS)" == "YES"

# --- Targets ------------------------------------------------------

.INCLUDE : set_ext.mk
.INCLUDE :	target.mk
.INCLUDE :	tg_ext.mk

